%define prerel %nil
%def_with ffmpeg
%def_with gpl
%def_with faac
%def_without x264
%def_disable static
%define _unpackaged_files_terminate_build 0

%define upstreamname libquicktime
%define _pkgdocdir %_docdir/%upstreamname-%version
%define pluginsdir %_libdir/%upstreamname-%version
%define abiver 102
%define libname %upstreamname%abiver
%define corename %libname-core

%define compat_version  1.0.2-alt7

Name: %libname
Version: 1.0.2
Release: alt10%prerel

Summary: A library for manipulating QuickTime files
%if_with gpl
License: GPL
%else
License: LGPL
%endif
Group: Video
Url: http://libquicktime.sourceforge.net
Packager: Afanasov Dmitry <ender@altlinux.org>

# http://dl.sf.net/%upstreamname/%upstreamname-%version%prerel.tar.gz
Source: %upstreamname-%version%prerel.tar
Patch: %upstreamname-1.0.2-opendivx-alt.patch
Patch1: %upstreamname-1.0.2-soname_hack-alt.patch
Patch2: libquicktime-1.0.2-alt-fix-libswscale.patch

# fix build against fresh ffmpeg
# http://www.mail-archive.com/pld-cvs-commit@lists.pld-linux.org/msg159942.html
Patch3: libquicktime-1.0.2-fix-ffmpeg-api.patch

# versioning plugins
Patch4: libquicktime-1.0.2-versioned-plugindir.patch

# ffmpeg with changed api
%define ffmpeg_ver 0.5-alt1
%define dv_ver 0.102

%if_with ffmpeg
BuildPreReq: ffmpeg-devel >= %ffmpeg_ver
%endif

BuildPreReq: libdv-devel >= %dv_ver

# Automatically added by buildreq on Sun Jan 29 2006
BuildRequires: ffmpeg-devel fontconfig freetype2 gcc-c++ glib2-devel libdv-devel libgtk+2-devel libjpeg-devel liblame-devel libogg-devel libpango-devel libpng-devel libstdc++-devel libvorbis-devel pkg-config xorg-x11-devel zlib-devel libx264-devel
# anyasm
BuildRequires: yasm nasm
BuildPreReq: libavc1394-devel libraw1394-devel libfaac-devel libfaad-devel libalsa-devel
#libjpeg-mmx-devel

# manually removed: glib-devel gcc-g77 gtk+-devel
#OldBuildRequires: XFree86-devel-static XFree86-libs ffmpeg-devel fontconfig freetype2 gcc-c++ glib2-devel hostinfo libGLU-devel libalsa-devel libatk-devel libavc1394-devel libdv-devel libgtk+2-devel libjpeg-devel libjpeg-mmx-devel liblame-devel libogg-devel libpango-devel libpng-devel libraw1394-devel libstdc++-devel libvorbis-devel pkgconfig xpm xvid zlib-devel libfaac-devel libfaad-devel
# TODO: libavcodec (!) (ffmpeg)
#--with-avcodec=PFX   Prefix where libavcodec is installed (optional)

%description
Libquicktime is a library for reading and writing QuickTime files on
UNIX systems. Video CODECs supported by this library are OpenDivX, MJPA,
JPEG Photo, PNG, RGB, YUV 4:2:2, and YUV 4:2:0 compression.  Supported
audio CODECs are Ogg Vorbis, IMA4, ulaw, and any linear PCM format.

Libquicktime is based on the quicktime4linux library. Libquicktime add
features such as a GNU build tools-based build process and dynamically
loadable CODECs.

%package -n %libname-core
Summary: library for reading and writing QuickTime files
Group: Video

Obsoletes: %upstreamname-xanim, %upstreamname-svq, %upstreamname-cinepak
Provides: %upstreamname-xanim = %version-%release, %upstreamname-svq  = %version-%release, %upstreamname-cinepak = %version-%release

Provides: libquicktime = %version-%release
Conflicts: libquicktime < %compat_version
Obsoletes: libquicktime

%description -n %libname-core
Libquicktime is a library for reading and writing QuickTime files on
UNIX systems. Video CODECs supported by this library are OpenDivX, MJPA,
JPEG Photo, PNG, RGB, YUV 4:2:2, and YUV 4:2:0 compression.  Supported
audio CODECs are Ogg Vorbis, IMA4, ulaw, and any linear PCM format.

Libquicktime is based on the quicktime4linux library. Libquicktime add
features such as a GNU build tools-based build process and dynamically
loadable CODECs.

%package -n %libname-plugins
Summary: Set of libquicktime plugins to support additional formats
Group: Video
Requires: %corename = %version-%release
%if_with faac
Requires: %libname-faac = %version-%release
%endif
Requires: %libname-faad2 = %version-%release
%if_with ffmpeg
Requires: %libname-ffmpeg = %version-%release
%endif
Requires: %libname-lame = %version-%release
Requires: %libname-vorbis = %version-%release
%if_with x264
Requires: %libname-x264 = %version-%release
%endif

Provides: %upstreamname-plugins = %version-%release

%description -n %libname-plugins
%summary

%package -n %libname-utils
Summary: Useful tools to operate at QuickTime files
Group: Video
Requires: %corename = %version-%release

# compatability deps
Provides: libquicktime-utils = %version-%release
Conflicts: libquicktime-utils < %compat_version
Obsoletes: libquicktime-utils

%description -n %libname-utils
Useful tools to operate on QuickTime files.

%package -n %libname-vorbis
Summary: Libquicktime plugin supporting the Ogg Vorbis codec
Group: Video
Requires: %corename = %version-%release

# compatability deps
Provides: libquicktime-vorbis = %version-%release
Conflicts: libquicktime-vorbis < %compat_version
Obsoletes: libquicktime-vorbis

%description -n %libname-vorbis
Libquicktime plugin supporting the Ogg Vorbis codec.

%package -n %libname-ffmpeg
Summary: Libquicktime plugin supporting the ffmpeg codec
Group: Video
Requires: %corename = %version-%release
Requires: libffmpeg >= %ffmpeg_ver

# compat deps
Provides: libquicktime-ffmpeg = %version-%release
Conflicts: libquicktime-ffmpeg < %compat_version
Obsoletes: libquicktime-ffmpeg

%description -n %libname-ffmpeg
Libquicktime plugin supporting the ffmpeg codec

%package -n %libname-opendivx
Summary: Libquicktime plugin supporting the opendivx codec
Group: Video
Requires: %corename = %version-%release

# compat deps
Provides: libquicktime-opendivx = %version-%release
Conflicts: libquicktime-opendivx < %compat_version
Obsoletes: libquicktime-opendivx

%description -n %libname-opendivx
Libquicktime plugin supporting the opendivx codec.

%package -n %libname-lame
Summary: Libquicktime plugin supporting the Lame codec
Group: Video
Requires: %corename = %version-%release

# compat deps
Provides: libquicktime-lame = %version-%release
Conflicts: libquicktime-lame < %compat_version
Obsoletes: libquicktime-lame

%description -n %libname-lame
Libquicktime plugin supporting the Lame codec.

%package -n %libname-dv
Summary: Libquicktime plugin supporting the DV codec
Group: Video
Requires: %corename = %version-%release
Requires: libdv >= %dv_ver

# compat deps
Provides: libquicktime-dv = %version-%release
Conflicts: libquicktime-dv < %compat_version
Obsoletes: libquicktime-dv

%description -n %libname-dv
Libquicktime plugin supporting the DV codec.

%if_with faac
%package -n %libname-faac
Summary: Libquicktime plugin supporting the Faac codec
Group: Video
Requires: %corename = %version-%release

# compat deps
Provides: libquicktime-faac = %version-%release
Conflicts: libquicktime-faac < %compat_version
Obsoletes: libquicktime-faac

%description -n %libname-faac
Libquicktime plugin supporting the Faac codec.
%endif

%package -n %libname-faad2
Summary: Libquicktime plugin supporting the Faad2 codec
Group: Video
Requires: %corename = %version-%release

# compat deps
Provides: libquicktime-faad2 = %version-%release
Conflicts: libquicktime-faad2 < %compat_version
Obsoletes: libquicktime-faad2

%description -n %libname-faad2
Libquicktime plugin supporting the Faad2 codec.

%package -n %libname-x264
Summary: Libquicktime plugin supporting the x264 codec
Group: Video
Requires: %corename = %version-%release

# compat deps
Provides: libquicktime-x264 = %version-%release
Conflicts: libquicktime-x264 < %compat_version
Obsoletes: libquicktime-x264

%description -n %libname-x264
Libquicktime plugin supporting the x264 codec.

%prep
%setup -q -n %upstreamname-%version%prerel
%patch -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
autoreconf -fisv

%define _optlevel 3
#--with-avcodec=/usr/lib
%configure --enable-gpl \
    %{subst_enable static} \
    %{subst_with x264} \
    --with-cpuflags="$CFLAGS" \
%ifnarch i586 i686 athlon
    --disable-mmx \
%endif

%make_build

%install
%make_install DESTDIR=%buildroot install
mv -f %buildroot%_docdir/%upstreamname %buildroot%_pkgdocdir
cp README TODO %buildroot%_pkgdocdir

# remove non-packaged files
%__rm -f %buildroot%pluginsdir/*.la

%files -n %corename
%_libdir/*.so.*
%dir %pluginsdir
%pluginsdir/lqt_audiocodec.so
%pluginsdir/lqt_rtjpeg.so
%pluginsdir/lqt_png.so
%pluginsdir/lqt_mjpeg.so
%pluginsdir/lqt_videocodec.so
%dir %_pkgdocdir
%_pkgdocdir/README
%_pkgdocdir/TODO

%files -n %libname-plugins

%files -n %libname-utils
%_bindir/*
%exclude %_bindir/lqt-config
%_man1dir/*

%files -n %libname-vorbis
%pluginsdir/lqt_vorbis.so

%if_with ffmpeg
%files -n %libname-ffmpeg
%pluginsdir/lqt_ffmpeg.so
%endif

%files -n %libname-opendivx
%pluginsdir/lqt_opendivx.so

%files -n %libname-lame
%pluginsdir/lqt_lame.so

%files -n %libname-dv
%pluginsdir/lqt_dv.so

%if_with faac
%files -n %libname-faac
%pluginsdir/lqt_faac.so
%endif

%files -n %libname-faad2
%pluginsdir/lqt_faad2.so

%if_with x264
%files -n %libname-x264
%pluginsdir/lqt_x264.so
%endif

%changelog
* Tue Jun 23 2009 Afanasov Dmitry <ender@altlinux.org> 1.0.2-alt10
- rebuild with libpng12-1.2.37-alt2

* Wed Apr 15 2009 Dmitry V. Levin <ldv@altlinux.org> 1.0.2-alt9
- Renamed to libquicktime102.

* Wed Apr 15 2009 Afanasov Dmitry <ender@altlinux.org> 1.0.2-alt8
- change packager

* Tue Apr 14 2009 Afanasov Dmitry <ender@altlinux.org> 1.0.2-alt7
- compat release (without development packages)
- use package name with soname appended now
- pack plugins into versioned directory
- fix build process with fresh ffmpeg (newer then 0.5). require
  ffmpeg with this version.
- fresh opendivx patch (use versioned plugin directory)
- remove locale files.

* Sun Jan 04 2009 Igor Vlasenko <viy@altlinux.ru> 1.0.2-alt6
- fixed repocop warnings

* Fri Jan 02 2009 Igor Vlasenko <viy@altlinux.ru> 1.0.2-alt5
- replaced dependency on anyasm

* Sat Dec 20 2008 Igor Vlasenko <viy@altlinux.ru> 1.0.2-alt4
- removed obsolete dependency libjpeg-mmx-devel

* Fri Dec 12 2008 Igor Vlasenko <viy@altlinux.ru> 1.0.2-alt3
- temporally disabled x264 plugin

* Mon Sep 29 2008 Igor Vlasenko <viy@altlinux.ru> 1.0.2-alt2
- fixed build with new ffmpeg

* Mon Jun 9 2008 Yury Aliaev <mutabor@altlinux.ru> 1.0.2-alt1
- new version
- reverted back OpenDivX support from 0.9.8
- development documentation put into the separate package devel-doc
- soname versioning hack added

* Sat Sep 16 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt6
- enabled ffmpeg (current Sisyphus allows it again)

* Sat May 06 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt5
- disabled ffmpeg
- faac plugin is enabled again

* Fri Feb 24 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt4
- disabled CPU build detection --with-cpuflags

* Wed Feb 08 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt3
- enabled ffmpeg

* Mon Feb 06 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt2
- s/xorg-x11-devel-static/xorg-x11-devel/

* Sun Jan 29 2006 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt1
- new version;
- changed license to GPL (enables faad2 && faac codecs)
- removed libjpeg-mmx-devel on x86_64 (thanks to rider@)

* Sun Dec 18 2005 Igor Vlasenko <viy@altlinux.ru> 0.9.8-alt0.1.pre2
- new version 0.9.8-pre2

* Sun Dec 18 2005 Igor Vlasenko <viy@altlinux.ru> 0.9.7-alt4
- applied spec cleanup of Vitaly Lipatov
  (removed broken dependency gtk+-devel)

* Fri Sep 30 2005 Igor Vlasenko <viy@altlinux.ru> 0.9.7-alt3
- fix #6687 (license is LGPL, not GPL)
- plugins removed from main package again (fixed alt1.1)

* Thu Sep 22 2005 Igor Vlasenko <viy@altlinux.ru> 0.9.7-alt2
- merged Vitaly Lipatov work with my backport branch; thanks

* Fri Sep 09 2005 Vitaly Lipatov <lav@altlinux.ru> 0.9.7-alt1.1
- fix owner of %_libdir/%upstreamname

* Sat Aug 27 2005 Vitaly Lipatov <lav@altlinux.ru> 0.9.7-alt1
- new version
- disable build with glib/gnome1 libraries

* Fri Aug 26 2005 Igor Vlasenko <viy@altlinux.ru> 0.9.7-alt0.M24.2
- added my patch to fix crashes on some MOVs

* Tue Jul 19 2005 Igor Vlasenko <viy@altlinux.org> 0.9.7-alt0.M24.1
- backport to M24, changed buildrequires

* Fri Jan 14 2005 Yuri N. Sedunov <aris@altlinux.ru> 0.9.4-alt1
- 0.9.4

* Wed Jul 21 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.9.3-alt1
- 0.9.3
- obsoletes libquicktime-{xanim,svq,cinepak}
- new Lame plugin.

* Mon Jun 07 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.9.2-alt1.3
- rebuild with libdv-0.102

* Tue Dec 02 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.9.2-alt1.2
- do not package .la files.
- do not build devel-static subpackage by default.
- use %%set_verify_elf_method textrel=relaxed, I can't fix rtjpeg
  asm code.

* Mon Oct 13 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.9.2-alt1.1
- disabled ffmpeg plugin due not ready for new ffmpeg.

* Wed Oct 01 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.9.2-alt1
- 0.9.2 release.

* Wed Nov 20 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.9.2-alt0.8pre1
- 0.9.2pre1.

* Sun Jul 21 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.9.1-alt1
- First build for Sisyphus.
